{$apptype console}
{$o-,r+,q+}
uses
  SysUtils, Math, testlib;

const
  MAX_N = 400000;

var
  na, np, n : longint;
  xa, ya : array[0..MAX_N - 1] of longint;
  xp, yp : array[0..MAX_N - 1] of longint;
  tx, ty : array[0..MAX_N - 1] of longint;
  i, shift : longint;
  res : boolean;

function check(dir : boolean; var res : boolean) : string;
var
  i : integer;
  en : string;
  s : int64;
begin
  s := 0;
  for i := 0 to np - 1 do begin
    s := s + int64(xp[i]) * yp[(i + 1) mod np] - int64(xp[(i + 1) mod np]) * yp[i];
  end;

  if (s > 0) then begin
    en := '     .';
  end else begin
    en := '     .';
  end;
  shift := -1;

  for i := 0 to np - 1 do begin
    if (xp[i] = xa[0]) and (yp[i] = ya[0]) then begin
      shift := i;
      break;
    end;
  end;

  if (shift = -1) then begin
    res := false;
    result := '      .';
    exit;
  end;

  for i := 0 to na - 1 do begin
    if (xa[i] <> xp[(i + shift) mod na]) or
       (ya[i] <> yp[(i + shift) mod na]) then begin
      res := false;
      result := format('  (%d, %d)   (%d, %d).', [xa[i], ya[i], xp[(i + shift) mod na], yp[(i + shift) mod na]]);
      exit;
    end;
  end;
  res := true;
  result := en;
end;

procedure reverse();
var
  i : integer;
begin
  for i := 0 to np - 1 do begin
    tx[np - 1 - i] := xp[i];
    ty[np - 1 - i] := yp[i];
  end;
  for i := 0 to np - 1 do begin
    xp[i] := tx[i];
    yp[i] := ty[i];
  end;
end;

var
  s : string;

begin
  n := inf.readLongint();
  na := ans.readLongint();
  for i := 0 to na - 1 do begin
    xa[i] := ans.readLongint();
    ya[i] := ans.readLongint();
  end;

  np := ouf.readLongint();
  
  if (np <> na) then begin
    quit(_wa, format('  : %d  %d', [np, na]));
  end;
  
  for i := 0 to np - 1 do begin
    xp[i] := ouf.readLongint();
    yp[i] := ouf.readLongint();
  end;
  res := false;
  s := check(false, res);

  if (not res) then begin
    reverse();
    s := check(true, res);
    if (not res) then begin
      quit(_wa, s);
    end;
  end;

  quit(_ok, format('n = %d,   %d (). ' + s, [n, na]));
end.
