import java.io.*;
import java.util.*;

public class swamp_vv{
	BufferedReader in;
	PrintWriter out;
	
	int MAXN = 100000;
	
	int n;
	int[] x;
	int[] y;
	int[] xs;
	int[] ys;
	int nn = 0;
	
	public void sol(int a, int b, int f){
		int max = -f*1000000000;
		int fi = -1;
		int la = -1;
		for(int i = a;i!=b;i++){
			if (i==n) {i = -1; continue;}
			if (max*f<f*y[i]){
				max = y[i]*f;
				fi = i;
				la = i;
			}
			if (max*f == f*y[i]){
				la = i;
			}
		}
		if (max*f<f*y[b]){
			max = y[b]*f;
			fi = b;
			la = b;
		}
		if (max*f == f*y[b]){
			la = b;
		}
		int cur = y[a];
		xs[nn] = x[a]; ys[nn] = y[a]; nn++;
		int g = 1;
		for(int i = a;i!=b;i++){
			if (i==n) {i = -1; continue;}
			if (cur*f*g<y[i]*f*g){
				xs[nn] = x[i]; 
				ys[nn] = cur;
				nn++; 
				cur = y[i];
				xs[nn] = x[i]; 
				ys[nn] = cur;
				nn++; 
			}
			if (cur==max) g = -1;
		}
		if (cur==max) g = -1;
		if (cur*f*g<y[b]*f*g){
			xs[nn] = x[b]; 
			ys[nn] = cur;
			nn++; 
			cur = y[b];
			xs[nn] = x[b]; 
			ys[nn] = cur;
			nn++; 
		}
		nn--;
	}
	
	public void run() throws Exception{
		in = new BufferedReader(new FileReader(new File("swamp.in")));
		out= new PrintWriter(new FileWriter(new File("swamp.out")));
		n = Integer.parseInt(in.readLine());
		if (n<4 || n>MAXN) throw new Exception("n is bad: "+n);
		x = new int[n+1];
		y = new int[n+1];
		xs = new int[n+1];
		ys = new int[n+1];
		int m = 0;
		int M = 0;
		int mi = -1;
		int Mi = -1;
		for(int i = 0; i<n;i++){
			String[] s = in.readLine().split(" ");
			x[i] = Integer.parseInt(s[0]);
			y[i] = Integer.parseInt(s[1]);
			if (x[m]>x[i] || (x[m] == x[i] && y[m]<y[i])){ m = i;}
			if (x[M]<x[i] || (x[M] == x[i] && y[M]>y[i])){ M = i;}
		}
		x[n] = x[0]; y[n] = y[0];
		for(int i = 1;i<=n;i++){
			if (x[i]!=x[i-1] && y[i]!=y[i-1]) throw new Exception("angle is not 90 degrees");
		}
		sol(m,M,1); 
		sol(M,m,-1);
		out.println(nn);
		for(int i = 0;i<nn;i++)
			out.println(xs[i]+" "+ys[i]);
		out.close();
	}
	
	public static void main(String[] args) throws Exception{
		new swamp_vv().run();
	}
}