#include <fstream>
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MANY = 0x7F7F7F7F;

class Point
{
public:
	int x, y;
};

bool operator<(const Point &a, const Point &b)
{
	if (a.y < b.y) return true;
	else return false;
}

int n;
vector<Point> pnt;

void Load()
{
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; i++)
	{
		Point p;
		scanf("%d%d", &p.x, &p.y);
		pnt.push_back(p);
	}
}

vector<Point> ans;
vector<Point> ans1, ans2;

void Build(int kf)
{
	ans1.clear();
	ans2.clear();
	int i;
	for (i = 0; i < pnt.size(); i++) pnt[i].y *= kf;
	sort(pnt.begin(), pnt.end());
	int tminx, tmaxx;
	tminx = MANY;
	tmaxx = -MANY;
	i = 0;
	while (i < pnt.size())
	{
		int j = i;
		while ((j < pnt.size() - 1) && (pnt[j + 1].y == pnt[i].y)) j++;
		int k;
		int minx, maxx;
		minx = MANY;
		maxx = -MANY;
		for (k = i; k <= j; k++)
		{
			if (pnt[k].x < minx) minx = pnt[k].x;
			if (pnt[k].x > maxx) maxx = pnt[k].x;
		}
		if (maxx > tmaxx)
		{
			Point p;
			if (tmaxx != -MANY)
			{
				p.y = pnt[i].y * kf;
				p.x = tmaxx;
				ans1.push_back(p);
			}
			p.y = pnt[i].y * kf;
			p.x = maxx;
			ans1.push_back(p);
			tmaxx = maxx;
		}
		if (minx < tminx)
		{
			Point p;
			if (tminx != MANY)
			{
				p.y = pnt[i].y * kf;
				p.x = tminx;
				ans2.push_back(p);
			}
			p.y = pnt[i].y * kf;
			p.x = minx;
			ans2.push_back(p);
			tminx = minx;
		}
		i = j + 1;
	}
	ans.clear();
	for (i = ans2.size() - 1; i >= 0; i--) ans.push_back(ans2[i]);
	for (i = 0; i < ans1.size(); i++) ans.push_back(ans1[i]);
}

vector<Point> allans;

void Solve()
{
	ans.clear();
	Build(1);
	allans = ans;
	ans.clear();
	Build(-1);
	reverse(ans.begin(), ans.end());
	int i;
	for (i = 0; i < ans.size(); i++) allans.push_back(ans[i]);
	printf("%d\n", allans.size());
	for (i = 0; i < allans.size(); i++)
	{
		printf("%d %d\n", allans[i].x, allans[i].y);
	}
}

int main()
{
	freopen("swamp.in", "rt", stdin);
	freopen("swamp.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
